window.Gleam.initSearch([{"doc":"gleam_cowboy","title":"gleam_cowboy","content":"# Gleam Cowboy! 🤠\n\nA Gleam HTTP service adapter for the [Cowboy][cowboy] web server.\n\nYou may want to consider using the [Mist][mist] web server instead as it has\nbetter performance, features type safe websockets, and is written entirely in\nGleam. It is also supported by the [Wisp][wisp] web framework.\n\n## Installation\n\n```sh\ngleam add gleam_cowboy\n```\n\n```gleam\nimport gleam/erlang/process\nimport gleam/http/cowboy\nimport gleam/http/response.{Response}\nimport gleam/http/request.{Request}\nimport gleam/bit_builder.{BitBuilder}\n\n// Define a HTTP service\n//\npub fn my_service(request: Request(t)) -&gt; Response(BitBuilder) {\n  let body = bit_builder.from_string(&quot;Hello, world!&quot;)\n\n  response.new(200)\n  |&gt; response.prepend_header(&quot;made-with&quot;, &quot;Gleam&quot;)\n  |&gt; response.set_body(body)\n}\n\n// Start it on port 3000!\n//\npub fn main() {\n  cowboy.start(my_service, on_port: 3000)\n  process.sleep_forever()\n}\n```\n\n## Limitations\n\nCowboy does not support duplicate HTTP headers so any duplicates specified by\nthe Gleam HTTP service will not be sent to the client.\n\n[cowboy]: https://github.com/ninenines/cowboy\n[mist]: https://github.com/rawhat/mist\n[wisp]: https://github.com/lpil/wisp\n","url":"index.html"},{"doc":"gleam/http/cowboy","title":"start","content":"pub fn start(\n  service: fn(Request(BitArray)) -&gt; Response(BytesBuilder),\n  on_port number: Int,\n) -&gt; Result(Pid, Dynamic)\n\nSynonyms:\ngleam/http/cowboy.start\ngleam/http/cowboy start","url":"gleam/http/cowboy.html#start"},{"doc":"gleam/http/cowboy","title":"gleam/http/cowboy","content":"","url":"gleam/http/cowboy.html"}]);